import permision from "@/js_sdk/wa-permission/permission.js"
export default {
	getFun({
		that,
		url,
		params,
		optionsKey,
		listKey,
		resKey,
		sa,
		okMsg,
		errMsg
	}) {
		uni.request({
			url: url.indexOf('https://api.naomishu.cn/') > -1 ? url : 'https://api.naomishu.cn/' + url,
			data: params,
			method: 'POST',
			header: {
				'content-type': 'application/x-www-form-urlencoded; charset=UTF-8'
			},
			success: (res) => {
				if (res.data.event == 100) {
					sa ? uni.showToast({
						title: okMsg ? okMsg : res.data.msg,
						icon: 'none'
					}) : ''
					return optionsKey ? that['_data'][optionsKey][listKey] = res.data[resKey] : that[
						'_data'][listKey] = res.data[resKey]
				} else {
					sa ? uni.showToast({
						title: errMsg ? errMsg : res.data.msg,
						icon: 'none'
					}) : ''
					return optionsKey ? that['_data'][optionsKey][listKey] = [] : that['_data'][optionsKey][
						listKey
					] = []
				}
			}


		})
	},
	toPage({
		url,
		type,
		funKey,
		params
	}) {
		let toFun = type ? type : 'navigateTo'
		uni[toFun](toFun == 'navigateBack' ? url : {
			url: url
		})

	},
	copy(code) {
		if (code && code.length > 0) {
			uni.setClipboardData({
				data: code, //当前点击的地址
				success: () => {
					//获取刚复制好的地址到剪切板，
					uni.getClipboardData({
						success: () => {
							uni.showToast({
								title: '已成功复制至粘贴板',
								icon: 'none'
							})
						}
					});
				}
			});
		} else {
			return uni.showToast({
				title: '内容为空,复制失败',
				icon: 'none'
			})
		}
	},
	/**
	 * @param {Object} time  时间
	 * @param {Object} type  0 年月日 1年月日时分秒 
	 */
	formatterDate(date, type) {
		const time = date ? new Date(date) : new Date();
		const year = time.getFullYear() // 获取年
		const month = time.getMonth() + 1 < 10 ? '0' + (time.getMonth() + 1) : time.getMonth() + 1 // 获取月
		const day = time.getDate() < 10 ? '0' + time.getDate() : time.getDate() // 获取日
		const hour = time.getHours() < 10 ? '0' + time.getHours() : time.getHours() // 获取小时
		const minute = time.getMinutes() < 10 ? '0' + time.getMinutes() : time.getMinutes() // 获取分钟
		const second = time.getSeconds() < 10 ? '0' + time.getSeconds() : time.getSeconds() // 获取秒
		if (type == 0) {
			return year + '-' + month + '-' + day
		} else if (type == 99) {
			return year + '年' + month + '月' + day + '日 ' + hour + ':' + minute
		} else if(type == 2){
			return year + '-' + month + '-' + day + ' ' + hour + ':' + minute
		}else{
			return year + '-' + month + '-' + day + ' ' + hour + ':' + minute + ':' + second
		}
	},
	// 手机号中间四位加密
	fillterPhone(phone) {
		if (phone) {
			const left = phone.toString().substr(0, 3)
			const right = phone.toString().substr(7)
			return left + '****' + right
		} else {
			return ''
		}
	},
	formatTimeHMS(ms, isShowFont) {
		let hour = Math.floor(ms / 60 / 60);
		let minutes = Math.floor(ms / 60);
		let seconds = Math.floor(ms % 60);
		hour = hour < 10 ? '0' + hour : hour
		minutes = minutes < 10 ? '0' + minutes : minutes
		seconds = seconds < 10 ? '0' + seconds : seconds
		if (!isShowFont) {
			if (hour == 0) {
				return `${minutes}:${seconds}`;
			} else {
				return `${hour}:${minutes}:${seconds}`;
			}
		} else {
			if (hour == 0) {
				return `${minutes}分${seconds}秒`;
			} else {
				return `${hour}时${minutes}分${seconds}秒`;
			}
		}
	},
	/**
	 * @param {Object} time 结束时间
	 * @param {Object} type 1 天时分秒 2 时分秒
	 */
	countDownTime(time, type) {
		var nowtime = new Date(), //获取当前时间
			endtime = new Date(time).getTime(); //定义结束时间
		let timestamp = endtime - nowtime.getTime(); //距离结束时间的毫秒数
		if (timestamp < 0) {
			return "截止了"
		}
		let D = Math.floor(timestamp / (1000 * 60 * 60 * 24)); //计算天数
		let H = Math.floor(timestamp / (1000 * 60 * 60) % 24); //计算小时数
		let m = Math.floor(timestamp / (1000 * 60) % 60); //计算分钟数
		let s = Math.floor(timestamp / 1000 % 60); //计算秒数
		if (H < 10) {
			H = '0' + H
		}
		if (m < 10) {
			m = '0' + m
		}
		if (s < 10) {
			s = '0' + s
		}
		if (type == 1) {
			return `${D}天${H}小时${m}分钟${s}秒`
		} else {
			return `${H}小时${m}分钟${s}秒`
		}
	},


	// 获取两个日期之间月份的差
	datemonth(date1, date2) {
		// 拆分年月日
		date1 = date1.split('-');
		// 得到月数
		date1 = parseInt(date1[0]) * 12 + parseInt(date1[1]);
		// 拆分年月日
		date2 = date2.split('-');
		// 得到月数
		date2 = parseInt(date2[0]) * 12 + parseInt(date2[1]);
		var m = Math.abs(date1 - date2); //Math.abs()取绝对值
		return m;
	},

	// 计算指定时间差
	calcTimeDiff(time1, time2, num) {
		const time = new Date();
		const year = time.getFullYear() // 获取年
		const month = time.getMonth() + 1 < 10 ? '0' + (time.getMonth() + 1) : time.getMonth() + 1 // 获取月
		const day = time.getDate() < 10 ? '0' + time.getDate() : time.getDate() // 获取日
		let platform = uni.getSystemInfoSync().platform;
		let newTime1 = 0
		let newTime2 = 0
		if (platform == 'ios') {
			newTime1 = new Date(year + '/' + month + '/' + day + ' ' + time1).getTime()
			newTime2 = new Date(year + '/' + month + '/' + day + ' ' + time2).getTime()
		} else {
			newTime1 = new Date(year + '-' + month + '-' + day + ' ' + time1).getTime()
			newTime2 = new Date(year + '-' + month + '-' + day + ' ' + time2).getTime()
		}
		const dif = newTime1 - newTime2
		const difArr = []
		if (dif > 0) {
			const abc = dif / num
			for (let i = 0; i < num; i++) {
				const addtime = new Date(newTime1 - (abc * (i + 1)))
				const hour = addtime.getHours() < 10 ? '0' + addtime.getHours() : addtime.getHours() // 获取小时
				const minute = addtime.getMinutes() < 10 ? '0' + addtime.getMinutes() : addtime.getMinutes() // 获取分钟
				difArr.push(hour + ':' + minute)
			}
		}
		return difArr
	},

	// 计算天数差
	calcDateDayDif(time1, time2) {
		const time1MS = new Date(time1).getTime()
		const time2MS = new Date(time2).getTime()
		const difDay = (time2MS - time1MS) / (1000 * 3600 * 24)
		return difDay
	},
	// 权限
	power(settingVal, content, contentVal) {
		// let setting = uni.getAppAuthorizeSetting()
		// READ_EXTERNAL_STORAGE 读取文件
		// WRITE_EXTERNAL_STORAGE 写入文件
		// CAMERA
		return new Promise((resolve, reject) => {
			// #ifdef APP-PLUS
			const platform = uni.getSystemInfoSync().platform
			if (platform == 'ios') {
				const camera = permision.judgeIosPermission("camera"); //判断ios是否给予摄像头权限
				console.log(camera, 'camera')
				//ios相册没权限，系统会自动弹出授权框
				//let photoLibrary = permision.judgeIosPermission("photoLibrary");//判断ios是否给予相册权限
				if (camera) {
					resolve();
				} else {
					reject('需要开启相机使用权限');
					uni.showModal({
						content: content ? content : `为了记录孩子的成长,需要您授权${contentVal}权限！`,
						cancelText: '暂不授权',
						confirmText: '前往授权',
						success: (res) => {
							if (res.confirm) {
								uni.openAppAuthorizeSetting({
									success(res) {
										console.log(res)
									}
								})
							}
						}
					})
				}
			} else {
				plus.android.requestPermissions(
					['android.permission.' + settingVal],
					function(resultObj) {
						console.log(resultObj, 'resultObj')
						resolve(resultObj)
						if (resultObj.deniedPresent.length > 0 || resultObj.deniedAlways.length > 0) {
							uni.showModal({
								content: content ? content : `为了记录孩子的成长,需要您授权${contentVal}权限！`,
								cancelText: '暂不授权',
								confirmText: '前往授权',
								success: (res) => {
									if (res.confirm) {
										uni.openAppAuthorizeSetting({
											success(res) {
												console.log(res)
											}
										})
									}
								}
							})
						}
					},
					function(error) {
						uni.showModal({
							content: content ? content : `为了记录孩子的成长,需要您授权${contentVal}权限！`,
							cancelText: '暂不授权',
							confirmText: '前往授权',
							success: (res) => {
								console.log(res, 'res')
								if (res.confirm) {
									uni.openAppAuthorizeSetting({
										success(res) {
											console.log(res)
										}
									})
								}
							},
							fail: (err) => {
								console.log(err)
							}
						})
					}
				)
			}
			// #endif
			// #ifdef MP
			resolve();
			// #endif
		})
	},

	// 过滤回显时间 
	filtrationTime(val) {
		const newTime = new Date()
		const time = new Date(val)
		const newY = newTime.getFullYear()
		const newM = newTime.getMonth()
		const newD = newTime.getDate()
		const timeY = time.getFullYear()
		const timeM = time.getMonth()
		const timeD = time.getDate()
		if (newY == timeY && newM == timeM && timeD == newD) {
			const ymd = val.split(' ')
			if(ymd[1]){
				const hms = ymd[1].split(':')
				return '今天' + ' ' + hms[0] + ':' + hms[1]
			}
			return '今天'
		} else {
			const ymd = val.split(' ')
			if(ymd[1]){
				const hms = ymd[1].split(':')
				return ymd[0] + ' ' + hms[0] + ':' + hms[1]
			}
			return ymd[0]
		}
	}
}